'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _xRay = require('x-ray');

var _xRay2 = _interopRequireDefault(_xRay);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _fs2 = require('fs');

var _fs = _interopRequireWildcard(_fs2);

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var fs = _bluebird2['default'].promisifyAll(_fs);
var cachedInfo = {};

try {
  cachedInfo = JSON.parse(fs.readFileSync('./tmp/info.json'));
} catch (e) {}

exports['default'] = function () {
  var books = JSON.parse(fs.readFileSync('./tmp/books.json'));
  var x = (0, _xRay2['default'])().concurrency(10).throttle(10, '1s');

  books = books.filter(function (book) {
    return !cachedInfo[book.id];
  });
  return _bluebird2['default'].map(books, function (book) {
    var id = book.id.replace('book', '');
    var q = x('http://ridibooks.com/v2/Detail?id=' + id, {
      category: '.info_category_wrap > a',
      rating: '.info_metadata01_wrap meta[itemprop="ratingValue"]@content'
    });
    return _bluebird2['default'].promisify(q)().then(function (info) {
      return _.merge(book, info);
    }).then(function (info) {
      console.log(info.title);return info;
    });
  }).then(function (results) {
    _.merge(cachedInfo, _.indexBy(results, 'id'));
    return fs.writeFileAsync('./tmp/info.json', JSON.stringify(cachedInfo));
  });
};

module.exports = exports['default'];