'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _superagent = require('superagent');

var _superagent2 = _interopRequireDefault(_superagent);

var _xRay = require('x-ray');

var _xRay2 = _interopRequireDefault(_xRay);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _fs = require('fs');

var fs = _interopRequireWildcard(_fs);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _driver = require('./driver');

var _driver2 = _interopRequireDefault(_driver);

var writeFile = _bluebird2['default'].promisify(fs.writeFile);

var agent = _superagent2['default'].agent();
var uri = 'https://ridibooks.com/account/action/login?user_id=' + _config2['default'].id + '&password=' + _config2['default'].password;

exports['default'] = function () {
  var req = agent.get(uri);
  return _bluebird2['default'].promisify(req.end, req)().then(function () {
    var x = (0, _xRay2['default'])().driver((0, _driver2['default'])(agent)).delay(100);
    var query = x('http://ridibooks.com/library', '#book_', [{
      title: 'span.title_text',
      author: '.book_metadata.author > a',
      series: '.series_book > .book_count',
      id: '.book_thumbnail label@for'
    }]).paginate('.btn_next > a@href');

    return _bluebird2['default'].promisify(query)();
  }).then(function (books) {
    books = books.map(function (book) {
      book.title = _.trim(book.title);
      return book;
    });
    return writeFile('./tmp/books.json', JSON.stringify(books)).then(function () {
      return books;
    });
  });
};

module.exports = exports['default'];